using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Drawing.Imaging;
using System.Text;
using System.Windows.Forms;


namespace binviz_0._1 {
    public partial class FrmPresence : Form {
        

        public FrmPresence() {
            InitializeComponent();
        }

        private void FrmPresence_Load(object sender, EventArgs e) {
            numericUpDown2.Minimum = 0;
            numericUpDown2.Maximum = numericUpDown1.Value - 1;
            numericUpDown2.Value = 0;
            
        }

        public void Plot(ref byte[] fileBufferArray, int fileSize, int offset) {
            int bytesDisplayed = (int)numericUpDown1.Value; // are you displaying 8,16,24,32 bits at a time, e.g. 1,2,3,4 bytes
            int columns = pictureBox1.Width;
            int rows = pictureBox1.Height;
            byte currentByte;
            ushort currentByte2;
            int currentColumn;
            int location = offset;
            int shift = (int)numericUpDown2.Value;

            Bitmap b = new Bitmap(columns, rows, PixelFormat.Format24bppRgb);
            BitmapData bmd = b.LockBits(new Rectangle(0, 0, columns, rows), ImageLockMode.ReadWrite, b.PixelFormat);

            unsafe {
                for (int j = 0; j < rows; j++) {
                    byte* row = (byte*)bmd.Scan0 + (j * bmd.Stride);
                 
                    for (int i = 0; i < (640/bytesDisplayed); i++)
                        {
                            if (location < (fileSize+shift)-1)
                            {
                                //Console.WriteLine(location+shift);
                                currentByte = fileBufferArray[location+shift];
                                row[currentByte * 3] = 255; //grayscale
                                row[currentByte * 3 + 1] = 255; 
                                row[currentByte * 3 + 2] = 255; 
                                location+=bytesDisplayed;
                            }
                        }
                    
                }
                
                b.UnlockBits(bmd);
                pictureBox1.Image = b;
            }//unsafe

        }

        private void pictureBox1_Click(object sender, EventArgs e)
        {

        }

        private void numericUpDown1_ValueChanged(object sender, EventArgs e)
        {
            numericUpDown2.Value = 0;              
            numericUpDown2.Maximum = numericUpDown1.Value-1;
            int temp = (int)Math.Pow(2.0,(double)numericUpDown1.Value *8) - 1;
            lblHi.Text = temp.ToString();
          
        }

        private void label3_Click(object sender, EventArgs e)
        {

        }
    }
}